summaryrefslogtreecommitdiff
path: root/init.d/swclock.in
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2009-10-13 08:03:45 +0100
committerRoy Marples <roy@marples.name>2009-10-13 08:03:45 +0100
commita8f6a9b6540ca301af625b4767df53860511a6dc (patch)
treea1dd01c8796d117c986f96fd702c3f3c6f2cdba5 /init.d/swclock.in
parentaaa0498bf86baa065656b6a5c37cff82c032eb6d (diff)
downloadopenrc-a8f6a9b6540ca301af625b4767df53860511a6dc.tar.gz
openrc-a8f6a9b6540ca301af625b4767df53860511a6dc.tar.bz2
openrc-a8f6a9b6540ca301af625b4767df53860511a6dc.tar.xz
Add new utility and init script swclock that sets the system time based on
the mtime of a file. It saves the shutdown time to this file also. This is handy for systems without a working RTC chip. Based on an idea by Michael A. Smith <michael@smith-li.com>. Fixes Gentoo #272073.
Diffstat (limited to 'init.d/swclock.in')
-rw-r--r--init.d/swclock.in27
1 files changed, 27 insertions, 0 deletions
diff --git a/init.d/swclock.in b/init.d/swclock.in
new file mode 100644
index 0000000..ab076c3
--- /dev/null
+++ b/init.d/swclock.in
@@ -0,0 +1,27 @@
+#!@PREFIX@/sbin/runscript
+# Copyright (c) 2009 Roy Marples <roy@marples.name>
+# All rights reserved. Released under the 2-clause BSD license.
+
+description="Sets the local clock to the mtime of a given file."
+
+depend()
+{
+ before *
+ keyword -openvz -prefix -uml -vserver -xenu
+}
+
+# swclock is an OpenRC built in
+
+start()
+{
+ ebegin "Setting the local clock based on last shutdown time"
+ swclock
+ eend $?
+}
+
+stop()
+{
+ ebegin "Saving the shutdown time"
+ swclock --save
+ eend $?
+}